function [mFR, mbic]=FR(x0,y0, bicopt)
%%original code by Hansheng Wang
%%modified by Helen: not requiring standardization and centering
%%using the large scale BIC

%  y=(y0-mean(y0));y=y/std(y);                                      %standardize y

[ss,ncov]=size(x0);													%get ss and ncov

%  x=x0;                                                            %get working x
%  %for j=1:ncov                                                    %standardize x, since the data is centered
%   %    x(:,j)=(x0(:,j)-mean(x0(:,j)));							%centralization
%   %    x(:,j)=x(:,j)/std(x(:,j));                                 %variance = 1
%   %end
X=x0;Y=y0;															%backup x and y

x = x0;
y = y0;
nStep=ceil(min(ncov,ss/4));                                         %maximum forward step
L2=zeros(nStep,1);mFR=[];ID=[1:ncov];                               %initialization
for k=1:nStep                                                       %do for each step
	L2(k)=norm(y);													%current RSS
	XL2=sum(x.^2,1)';												%Xj's L2 norm squared
    XL2=sqrt(XL2);                                                  % corrected 03/17/2016
    XL2(find(XL2==0))=1;                                            %kind of ignore zero columns
	r=abs(x'*y)./XL2;												%absolute partial corr
	id=find(max(r)==r);id=id(1);									%find best predictor
	ak=ID(id);														%find the best predictor
	mFR=[mFR,ak];													%include next predictor
	xj=x(:,id);
	if norm(xj)>0; 
		  xj=xj/norm(xj); 
	end;															%make norm(xj)=1
	x(:,id)=[];
	ID(id)=[];														%eliminate xj 
	y=y-xj*(xj'*y);
	x=x-xj*(xj'*x);													%do profiling
end

if (bicopt==0)
	BIC=2*log(L2)+[1:nStep]'*log(ss)/ss;				   
end
if (bicopt==1)
	BIC=2*log(L2)+[1:nStep]'*(log(ss)+2*log(ncov))/ss;
end
if (bicopt==2)
    BIC = 2*log(L2);   %Only RSS 
end
if (bicopt <0)
    BIC=2*log(L2)+[1:nStep]'*(log(ss)+2*log(-bicopt))/ss;
end

mbic=find(min(BIC)==BIC)-1;											%best stopping position
                                             

