function [mFRfull, mFR]=FRIs(x0,y0,bicopt)
%% two step with strong heredity constraint
    p = size(x0,2);
    [mFRfull1, mbic1]=FR(x0,y0,bicopt);                                                    %select the main effect
    if mbic1==0
        mFR1=[];
    else
        mFR1 = mFRfull1(1:mbic1);
    end
    %step 2
    %at the second-step, we force mFR1 in by projecting y0 and the 
    %interaction terms onto mFR1 and conduct FR on residuals
    
    if sum(size(mFR1))>0
        candyId = genIds(mFR1,p);
        xin = x0(:,mFR1);
        xout = genXXs(mFR1,x0);

        newy = y0-xin*(xin\y0);
    	newx = xout;	
        newx = xout-xin*(xin\xout);
   
        bicoptnew = 0;  %here we use standard BIC
        [mFRfull2, mbic2]=FR(newx,newy,bicoptnew);
        mFR2 = mFRfull2(1:mbic2);
        mFR = [mFR1,candyId(mFR2)];
        mFRfull=[mFR1, mFRfull2];
    else
        mFR = [];
        mFRfull =[];
    end
   
 
   
