function out=evaluate(B1,Index1,B0,Index0,X0,Y0,ncov) 
    %B1 is estimated main+interaction coefficient (in their order)
    %including intercept as the first entry
    %B0 is the true main+interaction coefficient (in their order)
    %true intercept =0
    %X0, Y0 are the test set
    b1=B1(1);
    lb=length(B1);
    if lb>1 
        B1=B1(2:lb);
    else
        B1=[];
    end
    
    DIM = ncov*(ncov+3)/2;                          %modified on Feb 27
    %ITB0 = B0((ncov+1):DIM);
    %ITB1 = B1((ncov+1):DIM);
    %b0 = B0(1:ncov);
    %b1 = B1(1:ncov);     
    IndexM0 = Index0(Index0<=ncov);
    IndexM1 = Index1(Index1<=ncov);
    IndexI0 = Index0(Index0>ncov);
    IndexI1 = Index1(Index1>ncov);
    TrueZero =setdiff((1:DIM),Index0);
    %SelZero  =setdiff((1:DIM),Index1);
    TrueZeroM=setdiff((1:ncov),Index0);
    %SelZeroM  =setdiff((1:ncov),Index1);
    TrueZeroI=setdiff(((ncov+1):DIM),Index0);
    %SelZeroI  =setdiff(((ncov+1):DIM),Index1);
    
    %underfit=max((abs(B0)>0).*(abs(B1)==0));                %check underfit or not. Reture value 0 or 1.
    underfit = 1-min(ismember(Index0,Index1));
    %overfit=max((abs(B0)==0).*(abs(B1)>0))*(1-underfit);    %check overfit
    overfit = (1-underfit)*(length(Index1)>length(Index0));
    correctfit=1-underfit-overfit;                          %check correctfit
    
   %munder=max((abs(b0)>0).*(abs(b1)==0));                %check underfit or not. Reture value 0 or 1.
   munder = 1-min(ismember(IndexM0,IndexM1));
   %mover=max((abs(b0)==0).*(abs(b1)>0))*(1-munder);    %check overfit
   mover = (1-underfit)*(length(IndexM1)>length(IndexM0));
   mcorrect=1-munder-mover;                          %check correctfit
    

    %ITunderfit=max((abs(ITB0)>0).*(abs(ITB1)==0));          %check underfit or not. Reture value 0 or 1.
    ITunderfit= 1-min(ismember(IndexI0,IndexI1));
    %IToverfit=max((abs(ITB0)==0).*(abs(ITB1)>0))*(1-ITunderfit);    %check overfit
    IToverfit = (1-underfit)*(length(IndexI1)>length(IndexI0));
    ITcorrectfit=1-ITunderfit-IToverfit;                    %check correctfit
    
    %cZero=sum((abs(B0)==0).*(abs(B1)==0));                  %No. of correct 0
    cZero = length(setdiff(TrueZero,Index1));
    %iZero=sum((abs(B0)>0).*(abs(B1)==0));                   %No. of incorrect 0
    iZero = length(setdiff(Index0,Index1));  
    %cZero=cZero/sum((abs(B0)==0));                      %percentage of true 0 being selected as 0
    cZero=cZero/length(TrueZero);
    %iZero=iZero/sum((abs(B0)>0));                       %percentage of important variables being missed
    iZero=iZero/length(Index0); 
    
    %mcZero=sum((abs(b0)==0).*(abs(b1)==0));                  %No. of correct 0
    mcZero = length(setdiff(TrueZeroM,Index1));
    %miZero=sum((abs(b0)>0).*(abs(b1)==0));                   %No. of incorrect 0
    miZero = length(setdiff(IndexM0,Index1)); 
    %mcZero=mcZero/sum((abs(b0)==0));                      %percentage of true 0 being selected as 0
    mcZero = mcZero/length(TrueZeroM);
    miZero = miZero/length(IndexM0);
    
    %ITcZero=sum((abs(ITB0)==0).*(abs(ITB1)==0));            %No. of correct 0
    %ITiZero=sum((abs(ITB0)>0).*(abs(ITB1)==0));             %No. of incorrect 0
    %ITcZero=ITcZero/sum((abs(ITB0)==0));                %percentage of true 0 being selected as 0
    %ITiZero=ITiZero/sum((abs(ITB0)>0));                 %percentage of important variables being missed
    ITcZero = length(setdiff(TrueZeroI,Index1));
    ITiZero = length(setdiff(IndexI0,Index1)); 
    ITcZero = ITcZero/length(TrueZeroI);
    ITiZero = ITiZero/length(IndexI0);
    
    %MSE=sqrt(sum((B1-B0).^2));                              %the MSE 
    %Rsq=(1-mean((X0*B1-Y0).^2)/var(Y0))*100;                %the out-of-sample R-Square
    %mSize=sum(abs(B1)>0);                                   %the model size
    %MSE = 0; %to be defined
    NN = max(union(Index1,Index0));
    NewB0 = zeros(NN,1);
    NewB1 = zeros(NN,1);
    NewB0(Index0) = B0;
    NewB1(Index1) = B1;
    % added b1^2 below 20140822
    MSE=sqrt(b1^2+sum((NewB1-NewB0).^2));                           %not good enough but...
    
    SelXX = genSelXXNN(X0,Index1);
    if (isempty(Index1))
        Rsq=0;
    else
        Rsq=(1-sum((b1+SelXX*B1-Y0).^2)/sum((Y0-mean(Y0)).^2))*100; % (corrected 20140821, old is) Rsq=(1-mean((SelXX*B1-Y0).^2)/var(Y0))*100;
    end
    mSize = length(Index1);
    
    cover=1-underfit;               %true model cover. prog. %modified from Hansheng's code, where cover+incorrect0==1, not correct
    ITcover=1-ITunderfit;           %true model cover. prog.
    mcover = 1-munder;
    out=[mcover,mcZero,miZero,mcorrect,ITcover,ITcZero,ITiZero,ITcorrectfit,mSize,MSE,Rsq];        %the final results
        
